commit 7d61f2d5db716bbd1389d543e488b944886b5319
Author: freddy77 <freddy77>
Date:   Wed Jan 27 15:32:02 2010 +0000

    implement pthread compatible mutex for windows (partial code from pthread-win32, LGPL 2 too)

diff --git a/ChangeLog b/ChangeLog
index 1a4476a..50266c4 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+Wed Jan 27 16:29:44 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tdsthread.h src/tds/Makefile.am src/tds/ptw32_MCS_lock.c:
+	* src/tds/win_mutex.c:
+	- implement pthread compatible mutex for windows (partial code from
+	  pthread-win32, LGPL 2 too)
+
 Wed Jan 27 13:20:42 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/sspi.c:
 	- use Negotiate and provide SPN in order to enable Kerberos support
@@ -2224,4 +2230,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2964 2010/01/27 12:22:00 freddy77 Exp $
+$Id: ChangeLog,v 1.2965 2010/01/27 15:32:02 freddy77 Exp $
diff --git a/include/tdsthread.h b/include/tdsthread.h
index fde1c52..c2e5c13 100644
--- a/include/tdsthread.h
+++ b/include/tdsthread.h
@@ -1,6 +1,7 @@
 /* FreeTDS - Library of routines accessing Sybase and Microsoft databases
  *
  * Copyright (C) 2005 Liam Widdowson
+ * Copyright (C) 2010 Frediano Ziglio
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Library General Public
@@ -21,34 +22,38 @@
 #ifndef TDSTHREAD_H
 #define TDSTHREAD_H 1
 
-/* $Id: tdsthread.h,v 1.4 2008/12/11 12:37:57 freddy77 Exp $ */
+/* $Id: tdsthread.h,v 1.5 2010/01/27 15:32:04 freddy77 Exp $ */
 
 #if defined(_THREAD_SAFE) && defined(TDS_HAVE_PTHREAD_MUTEX)
 
 #include <pthread.h>
 
-#define TDS_MUTEX_DECLARE(name) pthread_mutex_t name
 #define TDS_MUTEX_DEFINE(name) pthread_mutex_t name = PTHREAD_MUTEX_INITIALIZER
 #define TDS_MUTEX_LOCK(a) pthread_mutex_lock(a)
 #define TDS_MUTEX_UNLOCK(a) pthread_mutex_unlock(a)
-#define TDS_MUTEX_T pthread_mutex_t
-#define TDS_MUTEX_DECLARE_RECURSIVE(name) pthread_mutex_t name = PTHREAD_RECURSIVE_MUTEX_INITIALIZER_NP;
-#define TDS_MUTEX_INIT_RECURSIVE(mutex) do { \
-		pthread_mutexattr_t _attr; \
-		pthread_mutexattr_init(&_attr); \
-		pthread_mutexattr_settype(&_attr, PTHREAD_MUTEX_RECURSIVE); \
-		pthread_mutex_init(mutex, &_attr); \
-		pthread_mutexattr_destroy(&_attr); \
-	} while(0)
+
+#elif defined(_WIN32)
+
+typedef struct tds_win_mutex_t_ {
+	void *lock;
+	LONG done;
+	CRITICAL_SECTION crit;
+} tds_win_mutex_t;
+
+void tds_win_mutex_lock(tds_win_mutex_t *mutex);
+/* void tds_win_mutex_unlock(tds_win_mutex_t *mutex); */
+
+#define TDS_MUTEX_DEFINE(name) tds_win_mutex_t name = { NULL, 0 }
+#define TDS_MUTEX_LOCK(a) \
+	do { if ((a)->done) EnterCriticalSection(&(a)->crit); else tds_win_mutex_lock(a); } while(0)
+#define TDS_MUTEX_UNLOCK(a) LeaveCriticalSection(&(a)->crit)
+
 #else
 
-#define TDS_MUTEX_DECLARE(name) int name
 #define TDS_MUTEX_DEFINE(name) int name
 #define TDS_MUTEX_LOCK(a)
 #define TDS_MUTEX_UNLOCK(a)
-#define TDS_MUTEX_T int
-#define TDS_MUTEX_DECLARE_RECURSIVE(name) int name
-#define TDS_MUTEX_INIT_RECURSIVE(mutex)
+
 #endif
 
 #endif
diff --git a/src/tds/Makefile.am b/src/tds/Makefile.am
index df8f185..f694ee1 100644
--- a/src/tds/Makefile.am
+++ b/src/tds/Makefile.am
@@ -1,4 +1,4 @@
-# $Id: Makefile.am,v 1.71 2010/01/26 11:21:10 freddy77 Exp $
+# $Id: Makefile.am,v 1.72 2010/01/27 15:32:04 freddy77 Exp $
 
 SUBDIRS			=	unittests
 AM_CPPFLAGS		=	-I$(top_srcdir)/include
@@ -16,14 +16,14 @@ libtds_la_SOURCES=	mem.c token.c util.c login.c read.c \
 	locale.c threadsafe.c vstrbuild.c \
 	tdsstring.c getmac.c data.c net.c \
 	tds_checks.c tds_checks.h enum_cap.h log.c \
-	bulk.c \
+	bulk.c win_mutex.c \
 	$(AUTH_FILES)
 libtds_la_LDFLAGS=
 libtds_la_LIBADD=
 
 noinst_HEADERS		= tds_willconvert.h encodings.h num_limits.h types.h
 EXTRA_DIST		= tds_willconvert.h encodings.h num_limits.h types.h \
-	TDS.vcproj $(AUTH_FILES_DIST)
+	TDS.vcproj ptw32_MCS_lock.c $(AUTH_FILES_DIST)
 
 if HAVE_DOXYGEN
 doxyfile: $(srcdir)/tds.dox
diff --git a/src/tds/ptw32_MCS_lock.c b/src/tds/ptw32_MCS_lock.c
new file mode 100644
index 0000000..cdf6eda
--- /dev/null
+++ b/src/tds/ptw32_MCS_lock.c
@@ -0,0 +1,206 @@
+/*
+ * ptw32_MCS_lock.c
+ *
+ * Description:
+ * This translation unit implements queue-based locks.
+ *
+ * --------------------------------------------------------------------------
+ *
+ *      Pthreads-win32 - POSIX Threads Library for Win32
+ *      Copyright(C) 1998 John E. Bossom
+ *      Copyright(C) 1999,2005 Pthreads-win32 contributors
+ *
+ *      Contact Email: rpj@callisto.canberra.edu.au
+ *
+ *      The current list of contributors is contained
+ *      in the file CONTRIBUTORS included with the source
+ *      code distribution. The list can also be seen at the
+ *      following World Wide Web location:
+ *      http://sources.redhat.com/pthreads-win32/contributors.html
+ *
+ *      This library is free software; you can redistribute it and/or
+ *      modify it under the terms of the GNU Lesser General Public
+ *      License as published by the Free Software Foundation; either
+ *      version 2 of the License, or (at your option) any later version.
+ *
+ *      This library is distributed in the hope that it will be useful,
+ *      but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ *      Lesser General Public License for more details.
+ *
+ *      You should have received a copy of the GNU Lesser General Public
+ *      License along with this library in the file COPYING.LIB;
+ *      if not, write to the Free Software Foundation, Inc.,
+ *      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+/*
+ * About MCS locks:
+ *
+ * MCS locks are queue-based locks, where the queue nodes are local to the
+ * thread. The 'lock' is nothing more than a global pointer that points to
+ * the last node in the queue, or is NULL if the queue is empty.
+ *
+ * Originally designed for use as spin locks requiring no kernel resources
+ * for synchronisation or blocking, the implementation below has adapted
+ * the MCS spin lock for use as a general mutex that will suspend threads
+ * when there is lock contention.
+ *
+ * Because the queue nodes are thread-local, most of the memory read/write
+ * operations required to add or remove nodes from the queue do not trigger
+ * cache-coherence updates.
+ *
+ * Like 'named' mutexes, MCS locks consume system resources transiently -
+ * they are able to acquire and free resources automatically - but MCS
+ * locks do not require any unique 'name' to identify the lock to all
+ * threads using it.
+ *
+ * Usage of MCS locks:
+ *
+ * - you need a global ptw32_mcs_lock_t instance initialised to 0 or NULL.
+ * - you need a local thread-scope ptw32_mcs_local_node_t instance, which
+ *   may serve several different locks but you need at least one node for
+ *   every lock held concurrently by a thread.
+ *
+ * E.g.:
+ *
+ * ptw32_mcs_lock_t lock1 = 0;
+ * ptw32_mcs_lock_t lock2 = 0;
+ *
+ * void *mythread(void *arg)
+ * {
+ *   ptw32_mcs_local_node_t node;
+ *
+ *   ptw32_mcs_acquire (&lock1, &node);
+ *   ptw32_mcs_release (&node);
+ *
+ *   ptw32_mcs_acquire (&lock2, &node);
+ *   ptw32_mcs_release (&node);
+ *   {
+ *      ptw32_mcs_local_node_t nodex;
+ *
+ *      ptw32_mcs_acquire (&lock1, &node);
+ *      ptw32_mcs_acquire (&lock2, &nodex);
+ *
+ *      ptw32_mcs_release (&nodex);
+ *      ptw32_mcs_release (&node);
+ *   }
+ *   return (void *)0;
+ * }
+ */
+
+#if 0
+#include "implement.h"
+#include "pthread.h"
+#endif
+
+struct ptw32_mcs_node_t_
+{
+	struct ptw32_mcs_node_t_ **lock;	/* ptr to tail of queue */
+	struct ptw32_mcs_node_t_ *next;	/* ptr to successor in queue */
+	void *readyFlag;	/* set after lock is released by predecessor */
+	void *nextFlag;		/* set after 'next' ptr is set by successor */
+};
+
+typedef struct ptw32_mcs_node_t_ ptw32_mcs_local_node_t;
+typedef struct ptw32_mcs_node_t_ *ptw32_mcs_lock_t;
+
+/*
+ * ptw32_mcs_flag_set -- notify another thread about an event.
+ *
+ * Set event if an event handle has been stored in the flag, and
+ * set flag to -1 otherwise. Note that -1 cannot be a valid handle value.
+ */
+static inline void
+ptw32_mcs_flag_set(PVOID volatile *flag)
+{
+	HANDLE e = (HANDLE) InterlockedCompareExchangePointer(flag, (void *) -1, (void *) 0);
+
+	if ((HANDLE) 0 != e) {
+		/* another thread has already stored an event handle in the flag */
+		SetEvent(e);
+	}
+}
+
+/*
+ * ptw32_mcs_flag_set -- wait for notification from another.
+ *
+ * Store an event handle in the flag and wait on it if the flag has not been
+ * set, and proceed without creating an event otherwise.
+ */
+static inline void
+ptw32_mcs_flag_wait(PVOID volatile *flag)
+{
+	if (0 == InterlockedCompareExchangePointer(flag, 0, 0)) {	/* MBR fence */
+		/* the flag is not set. create event. */
+		HANDLE e = CreateEvent(NULL, FALSE, FALSE, NULL);
+
+		if (0 == InterlockedCompareExchangePointer(flag, (void *) e, (void *) 0)) {
+			/* stored handle in the flag. wait on it now. */
+			WaitForSingleObject(e, INFINITE);
+		}
+		CloseHandle(e);
+	}
+}
+
+/*
+ * ptw32_mcs_lock_acquire -- acquire an MCS lock.
+ *
+ * See:
+ * J. M. Mellor-Crummey and M. L. Scott.
+ * Algorithms for Scalable Synchronization on Shared-Memory Multiprocessors.
+ * ACM Transactions on Computer Systems, 9(1):21-65, Feb. 1991.
+ */
+static inline void
+ptw32_mcs_lock_acquire(ptw32_mcs_lock_t * lock, ptw32_mcs_local_node_t * node)
+{
+	ptw32_mcs_local_node_t *pred;
+
+	node->lock = lock;
+	node->nextFlag = 0;
+	node->readyFlag = 0;
+	node->next = 0;		/* initially, no successor */
+
+	/* queue for the lock */
+	pred = (ptw32_mcs_local_node_t *) InterlockedExchangePointer((void **) lock, node);
+
+	if (0 != pred) {
+		/* the lock was not free. link behind predecessor. */
+		pred->next = node;
+		ptw32_mcs_flag_set(&pred->nextFlag);
+		ptw32_mcs_flag_wait(&node->readyFlag);
+	}
+}
+
+/*
+ * ptw32_mcs_lock_release -- release an MCS lock.
+ *
+ * See:
+ * J. M. Mellor-Crummey and M. L. Scott.
+ * Algorithms for Scalable Synchronization on Shared-Memory Multiprocessors.
+ * ACM Transactions on Computer Systems, 9(1):21-65, Feb. 1991.
+ */
+static inline void
+ptw32_mcs_lock_release(ptw32_mcs_local_node_t * node)
+{
+	ptw32_mcs_lock_t *lock = node->lock;
+
+	ptw32_mcs_local_node_t *next = (ptw32_mcs_local_node_t *)
+		InterlockedCompareExchangePointer(&node->next, 0, 0);	/* MBR fence */
+
+	if (0 == next) {
+		/* no known successor */
+		if (node == (ptw32_mcs_local_node_t *) InterlockedCompareExchangePointer(lock, 0, node)) {
+			/* no successor, lock is free now */
+			return;
+		}
+
+		/* wait for successor */
+		ptw32_mcs_flag_wait(&node->nextFlag);
+		next = (ptw32_mcs_local_node_t *) InterlockedCompareExchangePointer(&node->next, 0, 0);	/* MBR fence */
+	}
+
+	/* pass the lock */
+	ptw32_mcs_flag_set(&next->readyFlag);
+}
+
diff --git a/src/tds/win_mutex.c b/src/tds/win_mutex.c
new file mode 100644
index 0000000..c1bba58
--- /dev/null
+++ b/src/tds/win_mutex.c
@@ -0,0 +1,57 @@
+/* FreeTDS - Library of routines accessing Sybase and Microsoft databases
+ * Copyright (C) 2010  Frediano Ziglio
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Library General Public
+ * License as published by the Free Software Foundation; either
+ * version 2 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Library General Public License for more details.
+ *
+ * You should have received a copy of the GNU Library General Public
+ * License along with this library; if not, write to the
+ * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+ * Boston, MA 02111-1307, USA.
+ */
+
+#if HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#if HAVE_STDLIB_H
+#include <stdlib.h>
+#endif /* HAVE_STDLIB_H */
+
+#ifdef _WIN32
+
+#if HAVE_STRING_H
+#include <string.h>
+#endif /* HAVE_STRING_H */
+
+#include "tds.h"
+#include "tdsthread.h"
+
+TDS_RCSID(var, "$Id: win_mutex.c,v 1.1 2010/01/27 15:32:04 freddy77 Exp $");
+
+#include "ptw32_MCS_lock.c"
+
+void
+tds_win_mutex_lock(tds_win_mutex_t * mutex)
+{
+	if (!InterlockedExchangeAdd(&mutex->done, 0)) {	/* MBR fence */
+		ptw32_mcs_local_node_t node;
+
+		ptw32_mcs_lock_acquire((ptw32_mcs_lock_t *) &mutex->lock, &node);
+		if (!mutex->done) {
+			InitializeCriticalSection(&mutex->crit);
+			mutex->done = 1;
+		}
+		ptw32_mcs_lock_release(&node);
+	}
+	EnterCriticalSection(&mutex->crit);
+}
+
+#endif

